/* Preferences.h 

   Preferences controller
    
   Created by Stefan Urbanek on Oct 20 1999
*/

#import <Foundation/NSObject.h>

@class NSCell;
@class NSMutableArray;
@class NSView;
@class NSWindow;
@class IconView;
@class PreferencesInfo;
@class PreferencesLayout;

@interface Preferences:NSObject
{
    NSWindow       *window;
    NSMutableArray *preferences;
    NSView         *layoutView;
    IconView       *iconView;
}
/* Obtaining shared preferences object */
+ sharedPreferences;

/* Preferences loading*/
- (void)loadPreferencesFromKnownDirectories;
- (void)loadPreferencesFromPath:(NSString *)aPath;
- (PreferencesInfo *)loadPreferences:(NSString *)aPath;

- (void)registerPreferences:(PreferencesInfo *)prefs;

- (PreferencesInfo *) preferencesWithName:(NSString *)name;
- (PreferencesInfo *) selectedPreferences;
- (PreferencesLayout *) selectedLayout;

- (void)showPreferences:(PreferencesInfo *)prefs;
- (PreferencesInfo *)selectedPreferences;
- (PreferencesLayout *)selectedLayout;
- (void)showPreferencesNamed:(NSString *)name;

- (void)savePreferences:sender;
- (void)saveAllPreferences:sender;
- (void)revertPreferences:sender;
- (void)revertAllPreferences:sender;

- (void) preferencesViewWillSwitchTo:(PreferencesInfo *)preferences;
- (void) preferencesViewDidSwitchTo:(PreferencesInfo *)preferences;

- (void)updatePreferencesWindowTitle:sender;

@end
