/* 
    main.m
*/

/* #import <Foundation/Foundation.h> */
#import <AppKit/AppKit.h>
#import "Preferences.h"
void createMenu();

int main(int argc, char **argv, char** env)
{
    NSApplication *app;
    NSAutoreleasePool* pool;
    Preferences *controller;

#if LIB_FOUNDATION_LIBRARY
    [NSProcessInfo initializeWithArguments:argv count:argc environment:env];
#endif

    pool = [NSAutoreleasePool new];

#ifndef NX_CURRENT_COMPILER_RELEASE
    initialize_gnustep_backend();
#endif

    controller = [Preferences sharedPreferences];
    app = [NSApplication sharedApplication];

    createMenu();
    [app setDelegate:controller];

    [app run];
    [controller release];
    [pool release];
    return 0;
}

void createMenu()
{
    NSMenu *menu;
    NSMenu *edit;
    NSMenu *pref;
    NSMenu *services;
    SEL action = @selector(method:);

    menu = [[NSMenu alloc] initWithTitle:@"Edit"];
    [menu addItemWithTitle:@"Info" action:action keyEquivalent:@""];
    [menu addItemWithTitle:@"Preferences" action:action keyEquivalent:@""];
    [menu addItemWithTitle:@"Edit" action:action keyEquivalent:@""];
    [menu addItemWithTitle:@"Services" action:action keyEquivalent:@""];
    [menu addItemWithTitle:@"Hide" action:@selector(hide:) keyEquivalent:@"h"];
    [menu addItemWithTitle:@"Quit" action:@selector(terminate:)
          keyEquivalent:@"q"];

    pref =[NSMenu new];
    [pref addItemWithTitle: @"Save" action:@selector(savePreferences:) keyEquivalent:@"s"];
    [pref addItemWithTitle: @"Save All" action:@selector(saveAllPreferences:) keyEquivalent:@"S"];
    [pref addItemWithTitle: @"Revert" action:@selector(revertPreferences:) keyEquivalent:@"r"];
    [pref addItemWithTitle: @"Revert All" action:@selector(revertAllPreferences:) keyEquivalent:@"r"];
    [menu setSubmenu: pref forItem: [menu itemWithTitle:@"Preferences"]];

    edit =[NSMenu new];
    [edit addItemWithTitle: @"Cut" action:@selector(cut:) keyEquivalent:@"x"];
    [edit addItemWithTitle: @"Copy" action:@selector(copy:) keyEquivalent:@"c"];
    [edit addItemWithTitle: @"Paste" action:@selector(paste:) keyEquivalent:@"v"];
    [edit addItemWithTitle: @"Delete" action:@selector(delete:) keyEquivalent:@""];
    [edit addItemWithTitle: @"Select All" action:@selector(selectAll:) keyEquivalent:@"a"];
    [menu setSubmenu: edit forItem: [menu itemWithTitle:@"Edit"]];

    services = [NSMenu new];
    [menu setSubmenu:services forItem:[menu itemWithTitle:@"Services"]];
    [[NSApplication sharedApplication] setServicesMenu:services];

    [[NSApplication sharedApplication] setMainMenu:menu];   // make menu the
    [menu update];
    [menu display];
}


